# Update Notes

> Source: https://truto.one/docs/api-reference/unified-crm-api/notes/update/

`PATCH /unified/crm/notes/{id}`

Resource: **Notes** · API: **Unified CRM API**

## Supported integrations

Affinity, Capsule, Close, Freshsales, Highlevel, HubSpot, Insightly, Keap, OnePageCRM, Pipedrive, Pipeliner, Planhat, Salesforce, Zendesk Sell, Zoho CRM

## Path parameters

- **`id`** _(string, required)_
  The ID of the resource.

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`contact`** _(array<object>)_
  The note's contact

## Request body

- **`content`** _(string)_
  The note's content
- **`owner`** _(object)_
  The note's owner
  - **`id`** _(string, required)_
    The note's owner's unique identifier
- **`contact`** _(array<object>)_
  Contact associated with the note. One of contact, account and opportunity is always required.
  - **`id`** _(string, required)_
    The contact's unique identifier
- **`account`** _(object)_
  Account associated with the note. One of contact, account and opportunity is always required.
  - **`id`** _(string, required)_
    The account's unique identifier
- **`opportunity`** _(array<object>)_
  Opportunity associated with the note. One of contact, account and opportunity is always required.
  - **`id`** _(string, required)_
    The opportunity's unique identifier
- **`title`** _(string)_
  The note's title
- **`lead`** _(array<object>)_
  The note's leads
  - **`id`** _(string, required)_
    The lead's unique identifier
- **`custom_fields`** _(unknown)_
- **`remote_data`** _(object)_
  Any additional data that should be passed as part of the request body. This data is not transformed by Truto and is passed as is to the remote API.

## Response body

- **`id`** _(string, required)_
  The note's unique identifier
- **`title`** _(string)_
  The note's title
- **`owner`** _(object)_
  The note's owner
  - **`id`** _(string)_
    The note's owner's unique identifier
- **`content`** _(string)_
  The note's content
- **`contact`** _(array<object>)_
  The note's contact
  - **`id`** _(string)_
    The contact's unique identifier
- **`account`** _(object)_
  The note's account
  - **`id`** _(string)_
    The account's unique identifier
- **`opportunity`** _(array<object>)_
  The note's opportunities
  - **`id`** _(string)_
    The opportunity's unique identifier
- **`lead`** _(array<object>)_
  The note's leads
  - **`id`** _(string)_
    The lead's unique identifier
- **`visibility`** _(string)_
  The note's visibility
  Allowed: `public`, `private`
- **`created_at`** _(string)_
  The date and time of the note's creation
- **`updated_at`** _(string)_
  The date and time of the note's last update
- **`urls`** _(array<object>)_
  The note's urls
  - **`url`** _(string)_
    The note's URL
  - **`type`** _(string)_
    The note's URL type
- **`remote_data`** _(object)_
  Raw data returned from the remote API call.

## Code examples

### curl

```bash
curl -X PATCH 'https://api.truto.one/unified/crm/notes/{id}?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json' \
  -d '{
  "content": "your_content",
  "owner": {},
  "contact": [],
  "account": {},
  "opportunity": [],
  "title": "your_title",
  "lead": [],
  "remote_data": {}
}'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const body = {
  "content": "your_content",
  "owner": {},
  "contact": [],
  "account": {},
  "opportunity": [],
  "title": "your_title",
  "lead": [],
  "remote_data": {}
};

const response = await fetch(`https://api.truto.one/unified/crm/notes/{id}?integrated_account_id=${integratedAccountId}`, {
  method: 'PATCH',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(body),
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/crm/notes/{id}"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}
payload = {
    "content": "your_content",
    "owner": {},
    "contact": [],
    "account": {},
    "opportunity": [],
    "title": "your_title",
    "lead": [],
    "remote_data": {}
}

response = requests.patch(url, headers=headers, params=params, json=payload)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.update(
  'crm',
  'notes',
  '<resource_id>',
  {
  "content": "your_content",
  "owner": {},
  "contact": [],
  "account": {},
  "opportunity": [],
  "title": "your_title",
  "lead": [],
  "remote_data": {}
},
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    result = await truto_api.unified_api.update(
        "crm",
        "notes",
        "<resource_id>",
        {
        "content": "your_content",
        "owner": {},
        "contact": [],
        "account": {},
        "opportunity": [],
        "title": "your_title",
        "lead": [],
        "remote_data": {}
},
        {"integrated_account_id": "<integrated_account_id>"}
    )
    print(result)

asyncio.run(main())
```
